
package edu.updehu.gbg.tap;

import java.io.*;
import java.net.URL;
import java.util.Date;

public class IOdemo {

    public static void main(String[] args) throws Exception {
        long t0=System.currentTimeMillis();
//        copiaByteAbyte();
//        copiaConBuffer();
//        copiaCharAChar();
//        copiaCharBuffered();
//        utf2Latin1();
//        copiaDeURL();
        objetosWrite();
        objetosRead();
        System.out.println((System.currentTimeMillis()-t0)+" ms.");

    }

    private static void copiaByteAbyte() throws FileNotFoundException, IOException {
        try (FileInputStream in=new FileInputStream("gato.jpg");
             FileOutputStream out=new FileOutputStream("gatoClon.jpg");) {
            int n;
            while ((n=in.read())!=-1) out.write(n);
        }
     }

      private static void copiaConBuffer() throws FileNotFoundException, IOException {
        try (BufferedInputStream in=new BufferedInputStream(new FileInputStream("gato.jpg"));
             BufferedOutputStream out=new BufferedOutputStream(new FileOutputStream("gatoClon.jpg"));) {
            int n;
            while ((n=in.read())!=-1) out.write(n);
        }
      }

        private static void copiaCharAChar() throws FileNotFoundException, IOException {
        try (FileReader in=new FileReader("quijote-es_utf.txt");
             FileWriter out=new FileWriter("quijote-es_utf-clon.txt");) {
            int n;
            while ((n=in.read())!=-1) out.write(n);
        }
     }

        private static void copiaCharBuffered() throws FileNotFoundException, IOException {
        try (BufferedReader in=new BufferedReader(new FileReader("quijote-es_utf.txt"));
             BufferedWriter out=new BufferedWriter(new FileWriter("quijote-es_utf-clon.txt"));) {
            String n;
            while ((n=in.readLine())!=null) out.write(n);
        }
     }

    private static void utf2Latin1() throws FileNotFoundException, IOException {
        try (BufferedReader in=new BufferedReader(new FileReader("quijote-es_utf.txt"));
              BufferedWriter out=new BufferedWriter(new FileWriter("quijote-es_utf-clon.txt"));) {
            String n;
            while ((n=in.readLine())!=null) out.write(n+"\n");
        }
     }

    private static void copiaDeURL() throws FileNotFoundException, IOException {
        String filename="CienAniosDeSoledad.txt";
        String recurso="http://gtts.ehu.es/German/Docencia/1920/TAP/temas/"+filename;

        try (BufferedReader in=new BufferedReader(new InputStreamReader(new URL(recurso).openStream()));
             BufferedWriter out=new BufferedWriter(new FileWriter(filename));) {
            String n;
            while ((n=in.readLine())!=null) out.write(n+"\n");
        }
     }

    /* PRUEBAS CON OBJETOS */
    static class Guardable implements Serializable{
        transient String h="valor inicial";
        Date d=new Date();

        @Override
        public String toString() {
            return "Guardable{" + "h=" + h + ", d=" + d + '}';
        }
    }
     private static void objetosWrite() throws FileNotFoundException, IOException {
        try (ObjectOutputStream out=new ObjectOutputStream(new FileOutputStream("tmp.objs"));) {
            Guardable obj=new Guardable();
            System.out.println("Objeto por defecto:       "+obj);
            obj.h="otro valor";
            System.out.println("Objeto a fichero:         "+obj);
            out.writeObject(obj);
        }
     }

     private static void objetosRead() throws FileNotFoundException, IOException, ClassNotFoundException {
        try (ObjectInputStream in=new ObjectInputStream(new FileInputStream("tmp.objs"));) {
            System.out.println("Objeto leído de fichero:  "+(Guardable)in.readObject());
        }
     }

}
